
 
 //3.3V         VCC              Power
 //GND          GND              Ground
// A4           SDA              I2C Data
 //A5           SCL              I2C Clock
// 2            INT              Interrupt


#include <Wire.h>
#include <SparkFun_APDS9960.h>
#define APDS9960_INT    2 // Needs to be an interrupt pin
SparkFun_APDS9960 apds = SparkFun_APDS9960();
int isr_flag = 0;
int gestnum = 0;
int mode = 1;
int modecl = 1;
int maxmodecl = 12; 
uint8_t proximity_data = 0;


#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif
#define PIN 6
Adafruit_NeoPixel strip = Adafruit_NeoPixel(60, PIN, NEO_GRB + NEO_KHZ800);







void setup() 
{
  // Set interrupt pin as input
  pinMode(APDS9960_INT, INPUT);
  
  Serial.begin(9600);
  Serial.println();
  Serial.println(F("--------------------------------"));
  Serial.println(F("SparkFun APDS-9960 - GestureTest"));
  Serial.println(F("--------------------------------"));
  
  // Initialize interrupt service routine
  attachInterrupt(0, interruptRoutine, FALLING);

  

  // Initialize APDS-9960 (configure I2C and initial values)
  if ( apds.init() ) 
  {
    Serial.println(F("APDS-9960 initialization complete"));
  } 
  else 
  {
    Serial.println(F("Something went wrong during APDS-9960 init!"));
  }


  
  // Start running the APDS-9960 gesture sensor engine
  if ( apds.enableGestureSensor(true) ) 
  {
    Serial.println(F("Gesture sensor is now running"));
  } 
  else 
  {
    Serial.println(F("Something went wrong during gesture sensor init!"));
  }


  // Adjust the Proximity sensor gain
  if ( !apds.setProximityGain(PGAIN_2X) ) 
  {
    Serial.println(F("Something went wrong trying to set PGAIN"));
  }


  // Start running the APDS-9960 proximity sensor (no interrupts)
  if ( apds.enableProximitySensor(false) ) 
  {
    Serial.println(F("Proximity sensor is now running"));
  } 
  else 
  {
    Serial.println(F("Something went wrong during sensor init!"));
  }  



  strip.begin();
  strip.setBrightness(255);
  strip.show(); // Initialize all pixels to 'off'
  
  for(int j=0; j<256; j++) 
  {
    for(int i=0; i<strip.numPixels(); i++) 
    {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(20);
  }
  strip.setBrightness(100);
  strip.show();

  modecl = 1;
}








void loop() 
{
   int startup = 1;
   
   while (mode == 1 && modecl == 1)   //COLOUR 1 DEEP PINK
   {
     if (startup == 1)
     {
      startup1(255,20,147);
     }
     startup = 0;
     checkgesture();
     
   }

   startup = 1;

   while (mode == 1 && modecl == 2)  //COLOUR 2 BLUE VIOLET
   {
     if (startup == 1)
     {
      startup1(138,43,226);
     }
     startup = 0;
     checkgesture();
     
   }

   startup = 1;

   while (mode == 1 && modecl == 3)   //COLOUR 3 ORANGE
   {
     if (startup == 1)
     {
      startup1(255,165,0);
     }
     startup = 0;
     checkgesture();
     
   }

   startup = 1;

   while (mode == 1 && modecl == 4)   //COLOUR 4 LIME GREEN
   {
     if (startup == 1)
     {
      startup1(50,205,50);
     }
     startup = 0;
     checkgesture();
     
   }

   startup = 1;

   while (mode == 1 && modecl == 5)   //COLOUR 5 CYAN/AQUA
   { 
     if (startup == 1)
     {
      startup1(0,255,255);
     }
     startup = 0;
     checkgesture();
     
   }

   startup = 1;

   while (mode == 1 && modecl == 6)   //COLOUR 6 MAGENTA
   {
     if (startup == 1)
     {
      startup1(255,0,255);
     }
     startup = 0;
     checkgesture();
     
   }

   startup = 1;

   while (mode == 1 && modecl == 7)   //COLOUR 7 CRIMSON
   {
     if (startup == 1)
     {
      startup1(220,20,60);
     }
     startup = 0;
     checkgesture();
     
   }

   startup = 1;

   while (mode == 1 && modecl == 8)   //COLOUR 8 GOLD
   {
     if (startup == 1)
     {
      startup1(255,215,0);
     }
     startup = 0;
     checkgesture();
     
   }

   startup = 1;

   while (mode == 1 && modecl == 9)   //COLOUR 9 SKY BLUE
   {
     if (startup == 1)
     {
      startup1(135,206,235);
     }
     startup = 0;
     checkgesture();
     
   }

   startup = 1;

   while (mode == 1 && modecl == 10)   //COLOUR 10 DARK ORCHID
   {
     if (startup == 1)
     {
      startup1(153,50,204);
     }
     startup = 0;
     checkgesture();
     
   }


   startup = 1;

   while (mode == 1 && modecl == 11)   //COLOUR 11 WHITE
   {
     if (startup == 1)
     {
      startup1(255,255,255);
     }
     startup = 0;
     checkgesture();
     
   }

    startup = 1;

   while (mode == 1 && modecl == 12)   //COLOUR OFF
   {
     if (startup == 1)
     {
      startup1(0,0,0);
     }
     startup = 0;
     checkgesture();
     
   }
   

   startup = 1;
   while (mode == 2 && modecl == 1)   //RANDOM COLOUR 1 
   {
     if (startup == 1)
     {
      randomcolour();
     }
     startup = 0;
     checkgesture();
     
   }

   
   startup = 1;
   while (mode == 2 && modecl == 2)   //RANDOM COLOUR 2 
   {
     if (startup == 1)
     {
      randomcolour();
     }
     startup = 0;
     checkgesture();
     
   }

   while (mode == 3 && modecl == 1)   //MIX COLOUR
   {
     uint16_t i, j;

     for(j=0; j<256; j++) 
     {
       for(i=0; i<strip.numPixels(); i++) 
       {
         strip.setPixelColor(i, Wheel((i+j) & 255));
       }
     checkgesture();
     strip.show();
     delay(20);
     }
     checkgesture();
   }

   while (mode == 3 && modecl == 2)   //MIX COLOUR
   {
     uint16_t i, j;

     for(j=0; j<256; j++) 
     {
       for(i=0; i<strip.numPixels(); i++) 
       {
         strip.setPixelColor(i, Wheel((i+j) & 255));
       }
     checkgesture();
     strip.show();
     delay(20);
     }
     checkgesture();
   }


  while (mode == 4 && modecl == 1)   //MIX COLOUR WHEEL 
  {
  uint16_t i, j;

  for(j=0; j<256*2; j++) 
   { // 2 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) 
    {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    checkgesture();
    strip.show();
    delay(15);
   }
   checkgesture();
  }

   while (mode == 4 && modecl == 2)   //MIX COLOUR WHEEL 
  {
  uint16_t i, j;

  for(j=0; j<256*2; j++) 
   { // 2 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) 
    {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    checkgesture();
    strip.show();
    delay(15);
   }
   checkgesture();
  }


}









void interruptRoutine() 
{
  isr_flag = 1;
}








void handleGesture() 
{
  if ( apds.isGestureAvailable() ) 
  {
    switch ( apds.readGesture() ) 
    {
      case DIR_UP:
        Serial.println("UP");
        mode = mode + 1;
        if (mode > 4){mode = 1;}
        modecl = 1;
        if (mode == 1){maxmodecl = 12;}
        else if(mode == 2){maxmodecl = 2;}
        else if(mode == 3){maxmodecl = 2;}
        else if(mode == 4){maxmodecl = 2;}
        gestnum = 1;
        Serial.println(mode);
        Serial.println(modecl);
        theaterChase(strip.Color(0, 255, 0), 70); // Blue
        break;
        
      case DIR_DOWN:
        Serial.println("DOWN"); 
        mode = mode - 1;
        if (mode < 1){mode = 4;}
        modecl = 1;
        if (mode == 1){maxmodecl = 12;}
        else if(mode == 2){maxmodecl = 2;}
        else if(mode == 3){maxmodecl = 2;}
        else if(mode == 4){maxmodecl = 2;}
        gestnum = 2;
        Serial.println(mode);
        Serial.println(modecl);
        theaterChase(strip.Color(0, 0, 255), 70); // Blue
        break;
        
      case DIR_LEFT:
        Serial.println("LEFT");
        gestnum = 3;
        modecl = modecl - 1;
        if (modecl < 1){modecl = maxmodecl;}
        Serial.println(mode);
        Serial.println(modecl);
        break;
        
      case DIR_RIGHT:
        Serial.println("RIGHT");
        gestnum = 4;
        modecl = modecl + 1;
        if (modecl > maxmodecl){modecl = 1;}
        Serial.println(mode);
        Serial.println(modecl);
        break;
        
      case DIR_NEAR:
        Serial.println("NEAR");
        gestnum = 5;
        break;
        
      case DIR_FAR:
        Serial.println("FAR");
        gestnum = 6;
        break;
      default:
        Serial.println("NONE");
        gestnum = 7;
    }
  }
}











void checkgesture()
{
  if( isr_flag == 1 ) 
  {
    detachInterrupt(0);
    handleGesture();
    if (gestnum == 6)
    {
      apds.init();
      apds.setProximityGain(PGAIN_2X);
      apds.enableProximitySensor(false);
      unsigned long StartTime = millis();
      unsigned long endtime = StartTime;
      int b = 0;
      while ((endtime - StartTime) <=3000) // do this loop for up to 3000mS
      {
         int raw = 0;
         if ( !apds.readProximity(proximity_data) ) 
         {
           Serial.println("Error reading proximity value");
         } 
         else 
         {
           Serial.print("Proximity: ");
           raw = proximity_data;
         }
         b = 255 - raw;
       
         Serial.println(b);
         if (b >= 15)
         {
         strip.setBrightness(b);
         strip.show();
         }
         else
         {b = 15;}
         delay(100);
         endtime = millis();
      }
      delay(3000);
      strip.setBrightness(b);
      apds.enableGestureSensor(true);
      
    }
    isr_flag = 0;
    attachInterrupt(0, interruptRoutine, FALLING);
  }  
}









void startup1(int r, int g, int b)
{
  for(uint16_t i=0; i<strip.numPixels(); i++) 
  {
    strip.setPixelColor(i, strip.Color(r, g, b));
    strip.show();
    delay(30);
  }
  
  
}





uint32_t Wheel(byte WheelPos) 
{
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
}







void randomcolour()
{
  int r = random(256);
  int g = random(256);
  int b = random(256);
  for(uint16_t i=0; i<strip.numPixels(); i++) 
  {
    strip.setPixelColor(i, strip.Color(r, g, b));
    strip.show();
    delay(30);
  } 
}










//Theatre-style crawling lights.
void theaterChase(uint32_t c, uint8_t wait) 
{
  for (int j=0; j<2; j++) 
  {  //do 3 cycles of chasing
    for (int q=0; q < 3; q++) 
    {
      for (uint16_t i=0; i < strip.numPixels(); i=i+3) 
      {
        strip.setPixelColor(i+q, c);    //turn every third pixel on
      }
      strip.show();

      delay(wait);

      for (uint16_t i=0; i < strip.numPixels(); i=i+3) {
        strip.setPixelColor(i+q, 0);        //turn every third pixel off
      }
    }
  }
}
